//       Title: PrintJob Manager V1.00
//  Written by: John White <yoingco@hotmail.com>
//  C Compiler: lcc-win32 Wedit v3.3 by Jacob Navia.
//
//  Special Thanks to: John Findlay for his wlib.lib and codings in general.
//                     Jim Buckeyne for his lcc-win32 forum help and for the
//                                  time difference code in this code.

#include <windows.h>
#include <windowsx.h>
#include <winuser.h>
#include <commctrl.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <winspool.h>
#include <liblistboxex.h> // This next include is from John Findlay`s excellent wlib.lib
//                           Library, should be copied into your Include folder. Also. Copy
// wlib.lib into your lib folder and then link this program with
// winspool.lib and wlib.lib.
#pragma lib <winspool.lib>

#define	IDAPPLICON 710

#define	IDBITMAP400 400   // Use the Resource Editor to create the bitmap resources.
#define	IDBITMAP700	700   // These are their standard/normal values from the Resource Editor.
#define	IDBITMAP800	800
#define	IDBITMAP900	900
#define	IDBITMAP1000 1000
#define	IDBITMAP1100 1100
#define	IDBITMAP1200 1200
#define	IDBITMAP1300 1300
#define	IDBITMAP1400 1400
#define	IDBITMAP1500 1500
#define	IDBITMAP1600 1600
#define	IDBITMAP1700 1700
#define	IDBITMAP1800 1800
#define	IDBITMAP1900 1900
#define	IDBITMAP2100 2100
#define	IDBITMAP2200 2200
#define	IDBITMAP2300 2300
#define	IDBITMAP2400 2400
#define	IDBITMAP2500 2500
#define	IDBITMAP2600 2600

HINSTANCE handle_Instance;
HCURSOR cursor_Handle;
HWND wnd0Ptr;
HWND lb0Ptr;
HWND btnPtrs[10];
HBITMAP bmPtrs[25];
HMENU menu;
HMENU submenu[5];
JOB_INFO_2 job_i2[1000];
JOB_INFO_2 job2;
HDC prt_dc;
HANDLE prt_Handle;
BOOL timer0_status=FALSE;
BOOL timer1_status=FALSE;
BOOL timer2_status=FALSE;

char *days[7]={
	"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
char *months[12]={
	"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
char *strCol[8]={
	"Computer Name","      Owner","           Document Name","        Status"," Page/s"," Printed","      Submitted Time/Date","     Buffer Size"};
int colwid[8]={
	94,84,152,90,56,56,154,98};

unsigned int mseconds=1500;
int timer0_Handle=0,timer1_Handle=0,timer2_Handle=0;
int oldjobs=0,totjobs=0,curjobs=0;
long rtn=0,rtnval=0;
char prt_error=0,prt_opened=0;
char tc0=0,tc1=0,tc2=0,ttmode=1,pmode=1,fmode=1,oldps=0,curps=0,deltime=4;
char oldtp=6,curtp=6,olddt=20,curdt=20;
char prt_name[50];
char port_name[50];
char driver_name[50];

LRESULT CALLBACK wnd0Procedure(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

BOOL InitApplication(void);
HWND Create_Window(DWORD,char *,char *,DWORD,int,int,int,int);
HWND Create_Owner(int,int,int,int);
BOOL Create_ToolTip(char,char *);
void timer0_off(void);
void timer0_on(void);
void timer0_code(void);
void timer1_off(void);
void timer1_on(void);
void timer1_code(void);
void timer2_off(void);
void timer2_on(void);
void timer2_code(void);
void create_menu(void);
void create_cursor(void);
void open_printer(void);
void enum_jobs2(DWORD,DWORD);
void get_job2(DWORD);
void update_status(void);
void update_lb(void);
void pause_status(char);
void delete_oldjobs(void);
void print_job(char);
void pause_job(void);
void delete_job(void);
void pause_all(void);
void print_all(char);
void delete_all(void);
void print_cursel(DWORD);
void pause_printer(void);
void resume_printer(void);
void close_printer(void);
void delete_dc(void);
void load_settings(char *);
void save_settings(char *);

BOOL InitApplication(void)
{
	WNDCLASS wc0;
	memset(&wc0,0,sizeof(WNDCLASS));
	wc0.style=CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS|CS_BYTEALIGNCLIENT|CS_BYTEALIGNWINDOW;
	wc0.lpfnWndProc=(WNDPROC)wnd0Procedure;
	wc0.hInstance=handle_Instance;
	wc0.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	wc0.lpszClassName="JWW0";
	wc0.lpszMenuName=NULL;
	wc0.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc0.hIcon=LoadIcon(handle_Instance,MAKEINTRESOURCE(IDAPPLICON));
	if (!RegisterClass(&wc0))
		return FALSE;
	return TRUE;
}

HWND Create_Window(DWORD extra,char *classname,char *title,DWORD style,int x,int y,int width,int height)
{
	return CreateWindowEx(extra,classname,title,style,x,y,width,height,NULL,NULL,handle_Instance,NULL);
}

HWND Create_Owner(int x,int y,int width,int height)
{
	return CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|BS_OWNERDRAW,x,y,width,height,wnd0Ptr,NULL,handle_Instance,NULL);
}

HWND CreateListBoxEx(DWORD dwExStyle,DWORD dwStyle,int x,int y,int cx,int cy,HWND hWndParent,int numcols,DWORD ctrlID);

LRESULT CALLBACK wnd0Procedure(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	POINT coords;
	PAINTSTRUCT ps;
	RECT rect;
	HGDIOBJ sbrush,old1font,old2font,cur1font,cur2font;
	UINT menuitem=0;
	UINT cstate;
	int wsize=0,hsize=0,counter=0,width=109;
	char stgbuf[256];

	switch (msg) {

	case WM_SPOOLERSTATUS:
		if (fmode==1) {
			pause_printer();
		}
		else {
			resume_printer();
		}
		oldjobs=totjobs;
		totjobs=lParam;
		if (totjobs<oldjobs) {
			update_lb();
		}
		else if (totjobs>oldjobs) {
			update_lb();
		}
		else {
			update_lb();
		}
		return 0;

	case WM_PAINT:
		if (hdc=BeginPaint(wnd0Ptr,&ps)) {
			if (GetClientRect(wnd0Ptr,&rect)) {
				if (SetBkMode(hdc,OPAQUE)) {
					rtn=SetBkColor(hdc,0x005888F8);
					if (rtn!=CLR_INVALID) {
						rtn=SetTextColor(hdc,0x00FFFFFF);
						if (rtn!=CLR_INVALID) {
							hsize=-MulDiv(4,GetDeviceCaps(hdc,LOGPIXELSX),72);
							wsize=-MulDiv(4,GetDeviceCaps(hdc,LOGPIXELSY),72);
							if (cur1font=CreateFont(hsize,wsize,1,1,400,0,0,0,1,0,0,0,0,"MS Sans Serif")) {
								if (sbrush=CreateSolidBrush(0x005888F8)) {
									if (FillRect(hdc,&rect,sbrush)) {
										old1font=SelectObject(hdc,cur1font);
										if ((old1font) && (long)old1font!=GDI_ERROR) {
											if (TextOut(hdc,6,450,"PrintJob Manager V1.00  -  yoingco@hotmail.com",46)) {

											}
											SelectObject(hdc,old1font);
										}
									}
									if (DeleteObject(sbrush)) {

									}
								}
								if (DeleteObject(cur1font)) {

								}
							}
						}
					}
				}
			}
			EndPaint(wnd0Ptr,&ps);
		}
		return 0;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT lpDs=(LPDRAWITEMSTRUCT)lParam;
			HDC hDC;
			hDC=CreateCompatibleDC(lpDs->hDC);
			if (hDC) {
				if (lpDs->hwndItem==btnPtrs[0]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[1]);
					}
					else {
						SelectObject(hDC,bmPtrs[0]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[1]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[3]);
					}
					else {
						SelectObject(hDC,bmPtrs[2]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[2]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[5]);
					}
					else {
						SelectObject(hDC,bmPtrs[4]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[3]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[7]);
					}
					else {
						SelectObject(hDC,bmPtrs[6]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[4]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[9]);
					}
					else {
						SelectObject(hDC,bmPtrs[8]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[5]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[11]);
					}
					else {
						SelectObject(hDC,bmPtrs[10]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[6]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[13]);
					}
					else {
						SelectObject(hDC,bmPtrs[12]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[7]) {
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[15]);
					}
					else {
						SelectObject(hDC,bmPtrs[14]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[8]) {
					width=130;
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[17]);
					}
					else {
						SelectObject(hDC,bmPtrs[16]);
					}
				}
				else if (lpDs->hwndItem==btnPtrs[9]) {
					width=130;
					if (lpDs->itemState & ODS_SELECTED) {
						SelectObject(hDC,bmPtrs[19]);
					}
					else {
						SelectObject(hDC,bmPtrs[18]);
					}
				}
				BitBlt(lpDs->hDC,0,0,width,61,hDC,0,0,SRCCOPY);
				DeleteDC(hDC);
			}
			return TRUE;
		}

	case WM_COMMAND:
		menuitem=LOWORD(wParam);
		if ((menuitem>0) && (menuitem<15)) {
			oldtp=curtp;
			curtp=menuitem;
			if (curtp!=oldtp) {
				CheckMenuItem(submenu[4],oldtp,MF_BYCOMMAND|MF_UNCHECKED);
				CheckMenuItem(submenu[4],curtp,MF_BYCOMMAND|MF_CHECKED);
				mseconds=(250*menuitem);
				if (menuitem==13) {
					mseconds=5000;
				}
				if (menuitem==14) {
					mseconds=1;
				}
				timer0_off();
				timer0_on();
			}
			break;
		}
		else if (menuitem==15) {
			cstate=GetMenuState(submenu[3],menuitem,MF_BYCOMMAND);
			if (MF_CHECKED & cstate) {
				pmode=0;
				CheckMenuItem(submenu[3],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
			}
			else {
				pmode=1;
				CheckMenuItem(submenu[3],menuitem,MF_BYCOMMAND|MF_CHECKED);
			}
			break;
		}
		else if ((menuitem>16) && (menuitem<25)) {
			olddt=curdt;
			curdt=menuitem;
			if (curdt!=olddt) {
				CheckMenuItem(submenu[3],olddt,MF_BYCOMMAND|MF_UNCHECKED);
				CheckMenuItem(submenu[3],curdt,MF_BYCOMMAND|MF_CHECKED);
				deltime=(menuitem-16);
			}
			break;
		}
		else if (menuitem==25) {
			cstate=GetMenuState(submenu[2],menuitem,MF_BYCOMMAND);
			if (MF_CHECKED & cstate) {
				fmode=0;
				CheckMenuItem(submenu[2],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
			}
			else {
				fmode=1;
				CheckMenuItem(submenu[2],menuitem,MF_BYCOMMAND|MF_CHECKED);
			}
			break;
		}
		else if (menuitem==27) {
			timer2_off();
			timer1_off();
			timer0_off();
			break;
		}
		else if (menuitem==28) {
			timer0_on();
			timer1_on();
			timer2_on();
			break;
		}
		else if (menuitem==30) {
			timer2_off();
			timer1_off();
			timer0_off();
			delete_dc();
			close_printer();
			open_printer();
			timer0_on();
			timer1_on();
			timer2_on();
			break;
		}
		else if (menuitem==35) {
			cstate=GetMenuState(submenu[1],menuitem,MF_BYCOMMAND);
			if (MF_CHECKED & cstate) {
				ttmode=0;
				CheckMenuItem(submenu[1],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
			}
			else {
				ttmode=1;
				CheckMenuItem(submenu[1],menuitem,MF_BYCOMMAND|MF_CHECKED);
			}
			break;
		}
		else if (menuitem==45) {
			save_settings("PJM.Settings");
			break;
		}

		if (HIWORD(wParam)==BN_CLICKED) {
			if ((HWND)lParam==btnPtrs[0]) {
				print_all(1);
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[1]) {
				delete_all();
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[2]) {
				pause_all();
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[3]) {
				print_all(0);
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[4]) {
				print_job(1);
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[5]) {
				delete_job();
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[6]) {
				pause_job();
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[7]) {
				print_job(0);
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[8]) {
				pause_printer();
				return 0;
			}
			else if ((HWND)lParam==btnPtrs[9]) {
				resume_printer();
				return 0;
			}
			return 0;
		}
		break;

	case LBXN_CLICK:
		print_cursel(lParam);
		break;

	case LBXN_HIGHLITE:
		counter=Lbx_GetHighItem(lb0Ptr);
		if (counter!=-1) {

		}
		break;

	case WM_SETFOCUS:
		SetFocus(lb0Ptr);
		return 0;

	case WM_SHOWWINDOW:
		if (wParam==TRUE) {

		}
		break;

	case WM_CREATE:
		lb0Ptr=CreateListBoxEx(LBXS_EX_GRIDLINES|LBXS_EX_FULLROWSELECT|LBXS_EX_NOTIFYDBCLICK|LBXS_EX_NOTIFYHIGHLITE,
			LBXS_SHOWSELALWAYS|LBXS_SUNKEN,0,0,794,304,hwnd,8,1200);
		if (lb0Ptr) {
			Lbx_SetColHeadTxtAll(lb0Ptr,8,strCol);
			Lbx_SetColWidthAll(lb0Ptr,8,colwid);
			Lbx_ShowWindow(lb0Ptr,SW_SHOW);
			return 0;
		}
		else {
			return -1;
		}

	case WM_DESTROY:
		EnableWindow(wnd0Ptr,FALSE);
		ShowWindow(wnd0Ptr,SW_HIDE);
		close_printer();
		delete_dc();
		PostQuitMessage(0);
		return 0;

	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
}

void update_lb(void)
{
	Lbx_DeleteAllRows(lb0Ptr);
	enum_jobs2(0,999);
}

void delete_dc(void)
{
	prt_error=1;
	if (prt_dc) {
		if (DeleteDC(prt_dc)) {
			prt_dc=0;
			prt_error=0;
		}
	}
}

void close_printer(void)
{
	prt_error=1;
	if (prt_Handle) {
		if (ClosePrinter(prt_Handle)) {
			prt_Handle=0;
			prt_error=0;
		}
	}
}

void pause_printer(void)
{
	if (prt_opened==1) {
		prt_error=1;
		if (SetPrinter(prt_Handle,0,0,PRINTER_CONTROL_PAUSE)) {
			prt_error=0;
		}
	}
}

void resume_printer(void)
{
	if (prt_opened==1) {
		prt_error=1;
		if (SetPrinter(prt_Handle,0,0,PRINTER_CONTROL_RESUME)) {
			prt_error=0;
		}
	}
}

void delete_all(void)
{
	if (prt_opened==1) {
		prt_error=1;
		if (SetPrinter(prt_Handle,0,0,PRINTER_CONTROL_PURGE)) {
			prt_error=0;
		}
	}
}

void get_job2(DWORD jobid)
{
	JOB_INFO_2 *job_info;
	int needed=0;
	char counter=0;
	if (prt_opened==1) {
		prt_error=1;
		rtn=GetJob(prt_Handle,jobid,2,0,0,&needed);
		if (rtn==0) {
			rtn=GetLastError();
			if (rtn==ERROR_INSUFFICIENT_BUFFER) {
				job_info=(JOB_INFO_2 *)GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,needed);
				if (job_info!=NULL) {
					rtn=GetJob(prt_Handle,jobid,2,(LPBYTE)job_info,needed,&needed);
					if (rtn) {
						rtn=GetLastError();
						if (rtn==0) {
							job2.JobId=job_info[counter].JobId;
							job2.pMachineName=job_info[counter].pMachineName;
							job2.pUserName=job_info[counter].pUserName;
							job2.pDocument=job_info[counter].pDocument;
							job2.Status=job_info[counter].Status;
							job2.TotalPages=job_info[counter].TotalPages;
							job2.Size=job_info[counter].Size;
							job2.Submitted=job_info[counter].Submitted;
							job2.PagesPrinted=job_info[counter].PagesPrinted;
							prt_error=0;
						}
					}
					GlobalFree(job_info);
				}
			}
		}
	}
}

void print_job(char rp)
{
	int counter=0;
	if (prt_opened==1) {
		pause_printer();
		for (counter=0;counter<curjobs;counter++) {
			get_job2(job_i2[counter].JobId);
			if (Lbx_GetItemState(lb0Ptr,counter)) {
				if (job2.Status & JOB_STATUS_PAUSED) {
					if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME)) {

					}
				}
			}
			else {
				if ((job2.Status & JOB_STATUS_SPOOLING) || (job2.Status==0)) {
					if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_PAUSE)) {

					}
				}
			}
		}
		update_status();
		if (rp==1) {
			resume_printer();
		}
	}
}

void pause_job()
{
	int counter=0;
	if (prt_opened==1) {
		for (counter=0;counter<curjobs;counter++) {
			if (Lbx_GetItemState(lb0Ptr,counter)) {
				get_job2(job_i2[counter].JobId);
				if ((job2.Status & JOB_STATUS_PRINTING) || (job2.Status & JOB_STATUS_SPOOLING) || (job2.Status==0)) {
					if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_PAUSE)) {

					}
				}
			}
		}
		update_status();
	}
}

void delete_job()
{
	int counter=0;
	if (prt_opened==1) {
		for (counter=0;counter<curjobs;counter++) {
			if (Lbx_GetItemState(lb0Ptr,counter)) {
				if (SetJob(prt_Handle,job_i2[counter].JobId,0,0,JOB_CONTROL_CANCEL)) {

				}
			}
		}
	}
}

void delete_oldjobs(void)
{
	SYSTEMTIME endtime;
	SYSTEMTIME rtntime;
	unsigned long long ftime1,ftime2,fdelta;
	int counter=0;
	WORD hour=0,min=0,sec=0,total=0;
	if (prt_opened==1) {
		GetSystemTime(&endtime);
		for (counter=0;counter<curjobs;counter++) {
			get_job2(job_i2[counter].JobId);
			SystemTimeToFileTime(&job2.Submitted,(LPFILETIME)&ftime1);
			SystemTimeToFileTime(&endtime,(LPFILETIME)&ftime2);
			fdelta=ftime2-ftime1;
			FileTimeToSystemTime((LPFILETIME)&fdelta,&rtntime);
			hour=(rtntime.wHour*60);
			min=rtntime.wMinute;
			sec=rtntime.wSecond;
			total=((hour+min)/30);
			if (total>=deltime) {
				if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_CANCEL)) {

				}
			}
		}
	}
}

void print_all(char rp)
{
	int counter=0;
	if (prt_opened==1) {
		pause_printer();
		for (counter=0;counter<curjobs;counter++) {
			get_job2(job_i2[counter].JobId);
			if (job2.Status & JOB_STATUS_PAUSED) {
				if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME)) {

				}
			}
		}
		update_status();
		if (rp==1) {
			resume_printer();
		}
	}
}

void pause_all()
{
	int counter=0;
	if (prt_opened==1) {
		pause_printer();
		for (counter=0;counter<curjobs;counter++) {
			get_job2(job_i2[counter].JobId);
			if ((job2.Status & JOB_STATUS_PRINTING) || (job2.Status & JOB_STATUS_SPOOLING) || (job2.Status==0)) {
				if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_PAUSE)) {

				}
			}
		}
		update_status();
	}
}

void print_cursel(DWORD cursel)
{
	if (prt_opened==1) {
		pause_printer();
		pause_all();
		get_job2(job_i2[cursel].JobId);
		if (job2.Status & JOB_STATUS_PAUSED) {
			if (SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME)) {

			}
		}
		resume_printer();
		if (pmode==1) {
			print_all(0);
		}
	}
}

void update_status(void)
{
	int counter=0;
	char *str[8];
	if (prt_opened==1) {
		for (counter=0;counter<8;counter++) {
			str[counter]=malloc(50);
		}
		for (counter=0;counter<curjobs;counter++) {
			get_job2(job_i2[counter].JobId);
			sprintf(str[0],job2.pMachineName);
			sprintf(str[1],job2.pUserName);
			sprintf(str[2],job2.pDocument);
			if (job2.Status) {
				if (job2.Status & JOB_STATUS_USER_INTERVENTION) {
					if (job2.Status & JOB_STATUS_PAPEROUT) {
						if (job2.Status & JOB_STATUS_PRINTING) {
							sprintf(str[3],"PaperOut/Printing");
						}
						else if (job2.Status & JOB_STATUS_DELETING) {
							sprintf(str[3],"PaperOut/Deleting");
						}
						else {
							sprintf(str[3],"PaperOut");
						}
					}
					else if (job2.Status & JOB_STATUS_OFFLINE) {
						if (job2.Status & JOB_STATUS_PRINTING) {
							sprintf(str[3],"OffLine/Printing");
						}
						else if (job2.Status & JOB_STATUS_DELETING) {
							sprintf(str[3],"OffLine/Deleting");
						}
						else {
							sprintf(str[3],"OffLine");
						}
					}
					else {
						if (job2.Status & JOB_STATUS_PRINTING) {
							sprintf(str[3],"Error/Printing");
						}
						else if (job2.Status & JOB_STATUS_DELETING) {
							sprintf(str[3],"Error/Deleting");
						}
						else {
							sprintf(str[3],"Error");
						}
					}
				}
				else if (job2.Status & JOB_STATUS_SPOOLING) {
					if (job2.Status & JOB_STATUS_PAUSED) {
						sprintf(str[3],"Spooling/Paused");
					}
					else if (job2.Status & JOB_STATUS_DELETING) {
						sprintf(str[3],"Spooling/Deleting");
					}
					else if (job2.Status & JOB_STATUS_ERROR) {
						sprintf(str[3],"Spooling/Error");
					}
					else {
						sprintf(str[3],"Spooling");
					}
				}
				else if (job2.Status & JOB_STATUS_PRINTING) {
					if (job2.Status & JOB_STATUS_PAUSED) {
						sprintf(str[3],"Printing/Paused");
					}
					else if (job2.Status & JOB_STATUS_DELETING) {
						sprintf(str[3],"Printing/Deleting");
					}
					else if (job2.Status & JOB_STATUS_ERROR) {
						sprintf(str[3],"Printing/Error");
					}
					else {
						sprintf(str[3],"Printing");
					}
				}
				else if (job2.Status & JOB_STATUS_DELETING) {
					if (job2.Status & JOB_STATUS_PAUSED) {
						sprintf(str[3],"Deleting/Paused");
					}
					else if (job2.Status & JOB_STATUS_ERROR) {
						sprintf(str[3],"Deleting/Error");
					}
					else {
						sprintf(str[3],"Deleting");
					}
				}
				else if (job2.Status & JOB_STATUS_PAUSED) {
					if (job2.Status & JOB_STATUS_DELETING) {
						sprintf(str[3],"Paused/Deleting");
					}
					else if (job2.Status & JOB_STATUS_ERROR) {
						sprintf(str[3],"Paused/Error");
					}
					else {
						sprintf(str[3],"Paused");
					}
				}
				else if (job2.Status & JOB_STATUS_PRINTED) {
					sprintf(str[3],"Printed");
				}
				else if (job2.Status & JOB_STATUS_DELETED) {
					sprintf(str[3],"Deleted");
				}
				else if (job2.Status & JOB_STATUS_ERROR) {
					sprintf(str[3],"Error");
				}
				else {
					sprintf(str[3],"Unknown");
				}
			}
			else {
				sprintf(str[3],"Ready");
			}
			sprintf(str[4],"%04d",job2.TotalPages);
			sprintf(str[5],"%04d",job2.PagesPrinted);
			sprintf(str[6],"%02d:%02d:%02d    %s %d %s %4d",(job2.Submitted.wHour),
				job2.Submitted.wMinute,job2.Submitted.wSecond,
				days[job2.Submitted.wDayOfWeek],job2.Submitted.wDay,
				months[(job2.Submitted.wMonth)-1],job2.Submitted.wYear);
			sprintf(str[7],"%02d Mb  %05d Kb",(job2.Size/1024000),(job2.Size/1024));
			Lbx_AddItem(lb0Ptr,counter,0,str[0]);
			Lbx_AddItem(lb0Ptr,counter,1,str[1]);
			Lbx_AddItem(lb0Ptr,counter,2,str[2]);
			Lbx_AddItem(lb0Ptr,counter,3,str[3]);
			Lbx_AddItem(lb0Ptr,counter,4,str[4]);
			Lbx_AddItem(lb0Ptr,counter,5,str[5]);
			Lbx_AddItem(lb0Ptr,counter,6,str[6]);
			Lbx_AddItem(lb0Ptr,counter,7,str[7]);
			Lbx_Update(lb0Ptr);
		}
		free(str[0]);
		for (counter=1;counter<8;counter++) {
			free(str[counter]);
		}
	}
}

void enum_jobs2(DWORD firstjob,DWORD numjobs)
{
	JOB_INFO_2 *job_info;
	int needed=0,returned=0;
	int counter=0;
	char *str[8];
	if (prt_opened==1) {
		prt_error=1;
		for (counter=0;counter<8;counter++) {
			str[counter]=malloc(50);
		}
		rtn=EnumJobs(prt_Handle,firstjob,numjobs,2,0,0,&needed,&returned);
		if (rtn==0) {
			rtn=GetLastError();
			if (rtn==ERROR_INSUFFICIENT_BUFFER) {
				job_info=(JOB_INFO_2 *)GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,needed);
				if (job_info!=NULL) {
					rtn=EnumJobs(prt_Handle,firstjob,numjobs,2,(LPBYTE)job_info,needed,&needed,&returned);
					if (rtn) {
						rtn=GetLastError();
						if (rtn==0) {
							for (counter=0;counter<returned;counter++) {
								job_i2[counter].JobId=job_info[counter].JobId;
								job_i2[counter].pMachineName=job_info[counter].pMachineName;
								job_i2[counter].pUserName=job_info[counter].pUserName;
								job_i2[counter].pDocument=job_info[counter].pDocument;
								job_i2[counter].Status=job_info[counter].Status;
								job_i2[counter].TotalPages=job_info[counter].TotalPages;
								job_i2[counter].Size=job_info[counter].Size;
								job_i2[counter].Submitted=job_info[counter].Submitted;
								job_i2[counter].PagesPrinted=job_info[counter].PagesPrinted;
								sprintf(str[0],job_info[counter].pMachineName);
								sprintf(str[1],job_info[counter].pUserName);
								sprintf(str[2],job_info[counter].pDocument);
								if (job_info[counter].Status) {
									if (job_info[counter].Status & JOB_STATUS_USER_INTERVENTION) {
										if (job_info[counter].Status & JOB_STATUS_PAPEROUT) {
											if (job_info[counter].Status & JOB_STATUS_PRINTING) {
												sprintf(str[3],"PaperOut/Printing");
											}
											else if (job_info[counter].Status & JOB_STATUS_DELETING) {
												sprintf(str[3],"PaperOut/Deleting");
											}
											else {
												sprintf(str[3],"PaperOut");
											}
										}
										else if (job_info[counter].Status & JOB_STATUS_OFFLINE) {
											if (job_info[counter].Status & JOB_STATUS_PRINTING) {
												sprintf(str[3],"OffLine/Printing");
											}
											else if (job_info[counter].Status & JOB_STATUS_DELETING) {
												sprintf(str[3],"OffLine/Deleting");
											}
											else {
												sprintf(str[3],"OffLine");
											}
										}
										else {
											if (job_info[counter].Status & JOB_STATUS_PRINTING) {
												sprintf(str[3],"Error/Printing");
											}
											else if (job_info[counter].Status & JOB_STATUS_DELETING) {
												sprintf(str[3],"Error/Deleting");
											}
											else {
												sprintf(str[3],"Error");
											}
										}
									}
									else if (job_info[counter].Status & JOB_STATUS_SPOOLING) {
										if (job_info[counter].Status & JOB_STATUS_PAUSED) {
											sprintf(str[3],"Spooling/Paused");
										}
										else if (job_info[counter].Status & JOB_STATUS_DELETING) {
											sprintf(str[3],"Spooling/Deleting");
										}
										else if (job_info[counter].Status & JOB_STATUS_ERROR) {
											sprintf(str[3],"Spooling/Error");
										}
										else {
											sprintf(str[3],"Spooling");
										}
									}
									else if (job_info[counter].Status & JOB_STATUS_PRINTING) {
										if (job_info[counter].Status & JOB_STATUS_PAUSED) {
											sprintf(str[3],"Printing/Paused");
										}
										else if (job_info[counter].Status & JOB_STATUS_DELETING) {
											sprintf(str[3],"Printing/Deleting");
										}
										else if (job_info[counter].Status & JOB_STATUS_ERROR) {
											sprintf(str[3],"Printing/Error");
										}
										else {
											sprintf(str[3],"Printing");
										}
									}
									else if (job_info[counter].Status & JOB_STATUS_DELETING) {
										if (job_info[counter].Status & JOB_STATUS_PAUSED) {
											sprintf(str[3],"Deleting/Paused");
										}
										else if (job_info[counter].Status & JOB_STATUS_ERROR) {
											sprintf(str[3],"Deleting/Error");
										}
										else {
											sprintf(str[3],"Deleting");
										}
									}
									else if (job_info[counter].Status & JOB_STATUS_PAUSED) {
										if (job_info[counter].Status & JOB_STATUS_DELETING) {
											sprintf(str[3],"Paused/Deleting");
										}
										else if (job_info[counter].Status & JOB_STATUS_ERROR) {
											sprintf(str[3],"Paused/Error");
										}
										else {
											sprintf(str[3],"Paused");
										}
									}
									else if (job_info[counter].Status & JOB_STATUS_PRINTED) {
										sprintf(str[3],"Printed");
									}
									else if (job_info[counter].Status & JOB_STATUS_DELETED) {
										sprintf(str[3],"Deleted");
									}
									else if (job_info[counter].Status & JOB_STATUS_ERROR) {
										sprintf(str[3],"Error");
									}
									else {
										sprintf(str[3],"Unknown");
									}
								}
								else {
									sprintf(str[3],"Ready");
								}
								sprintf(str[4],"%04d",job_info[counter].TotalPages);
								sprintf(str[5],"%04d",job_info[counter].PagesPrinted);
								sprintf(str[6],"%02d:%02d:%02d    %s %d %s %4d",(job_info[counter].Submitted.wHour),
									job_info[counter].Submitted.wMinute,job_info[counter].Submitted.wSecond,
									days[job_info[counter].Submitted.wDayOfWeek],job_info[counter].Submitted.wDay,
									months[(job_info[counter].Submitted.wMonth)-1],job_info[counter].Submitted.wYear);
								sprintf(str[7],"%04d",job_info[counter].Size);
								Lbx_AddRowAll(lb0Ptr,8,str);
								Lbx_Update(lb0Ptr);
							}
							curjobs=returned;
							prt_error=0;
						}
					}
					GlobalFree(job_info);
				}
			}
		}
		free(str[0]);
		for (counter=1;counter<8;counter++) {
			free(str[counter]);
		}
	}
}

void pause_status(char sts)
{
	PRINTER_INFO_2 *prt_info;
	int needed=0;
	char stgbuf[256];
	if (prt_opened==1) {
		prt_error=1;
		rtn=GetPrinter(prt_Handle,2,0,0,&needed);
		if (rtn==0) {
			rtn=GetLastError();
			if (rtn==ERROR_INSUFFICIENT_BUFFER) {
				prt_info=(PRINTER_INFO_2 *)GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,needed);
				if (prt_info!=NULL) {
					rtn=GetPrinter(prt_Handle,2,(LPBYTE)prt_info,needed,&needed);
					if (rtn) {
						rtn=GetLastError();
						if (rtn==0) {
							prt_error=0;
							if (prt_info[0].Status & PRINTER_STATUS_PAUSED) {
								lstrcpy(stgbuf,"   Paused  -  ");
								oldps=curps;
								curps=1;
							}
							else {
								lstrcpy(stgbuf,"   UnPaused  -  ");
								oldps=curps;
								curps=0;
							}
							lstrcat(stgbuf,"Default: ");
							lstrcat(stgbuf,prt_name);
							if ((oldps!=curps) || (sts==0)) {
								SetWindowText(wnd0Ptr,stgbuf);
							}
						}
					}
					GlobalFree(prt_info);
				}
			}
		}
	}
}

void open_printer()
{
	PRINTER_INFO_5 *prt_info;
	PRINTER_DEFAULTS prt_defaults;
	char stgbuf[120];
	char *printer, *driver, *port;
	prt_error=1;
	GetProfileString("windows","device",",,,",stgbuf,120);
	if ((printer=strtok(stgbuf,(const char *) ",")) &&
		    (driver=strtok((char *) NULL,(const char *) ", ")) &&
		    (port=strtok((char *) NULL,(const char *) ", ")))
		strcpy(prt_name,printer);
	strcpy(port_name,port);
	strcpy(driver_name,driver);
	prt_defaults.pDatatype=NULL;
	prt_defaults.pDevMode=0;
	prt_defaults.DesiredAccess=PRINTER_ALL_ACCESS;
	if (OpenPrinter(prt_name,&prt_Handle,&prt_defaults)) {
		prt_opened=1;
		//prt_dc=CreateDC(driver,printer,port,NULL);
		prt_dc=CreateDC(NULL,prt_name,NULL,0);
		if (prt_dc) {
			prt_error=0;
		}
	}
}

void create_menu(void)
{
	MENUITEMINFO mi[5];
	MENUITEMINFO si[45];
	int counter=0;
	si[44].dwTypeData="Save Settings";
	si[43].dwTypeData="";
	si[42].dwTypeData="";
	si[41].dwTypeData="";
	si[40].dwTypeData="";
	si[39].dwTypeData="";
	si[38].dwTypeData="";
	si[37].dwTypeData="";
	si[36].dwTypeData="";
	si[35].dwTypeData="";
	si[34].dwTypeData="Create/Use Button ToolTips    ";
	si[33].dwTypeData="";
	si[32].dwTypeData="";
	si[31].dwTypeData="";
	si[30].dwTypeData="";
	si[29].dwTypeData="Get The Default Printer  ";
	si[28].dwTypeData="";
	si[27].dwTypeData="Start PrintJob Manager   ";
	si[26].dwTypeData="Stop PrintJob Manager    ";
	si[25].dwTypeData="";
	si[24].dwTypeData="ALWAYS Pause the Printer ";
	si[23].dwTypeData="Auto-Delete OLD Jobs after         4 Hours ";
	si[22].dwTypeData="Auto-Delete OLD Jobs after      3 Hours   ";
	si[21].dwTypeData="Auto-Delete OLD Jobs after         3 Hours ";
	si[20].dwTypeData="Auto-Delete OLD Jobs after      2 Hours   ";
	si[19].dwTypeData="Auto-Delete OLD Jobs after         2 Hours ";
	si[18].dwTypeData="Auto-Delete OLD Jobs after      1 Hours   ";
	si[17].dwTypeData="Auto-Delete OLD Jobs after         1 Hour  ";
	si[16].dwTypeData="Auto-Delete OLD Jobs after       30 Minutes";
	si[15].dwTypeData="";
	si[14].dwTypeData="READY All Jobs After A Double-Click Print";
	si[13].dwTypeData=" &Fastest    ";
	si[12].dwTypeData=" &Slowest    ";
	si[11].dwTypeData="  3   Seconds";
	si[10].dwTypeData="2  Seconds  ";
	si[9].dwTypeData="2  Seconds  ";
	si[8].dwTypeData="2  Seconds  ";
	si[7].dwTypeData="  2   Seconds";
	si[6].dwTypeData="1  Seconds  ";
	si[5].dwTypeData="1  Seconds  ";
	si[4].dwTypeData="1  Seconds  ";
	si[3].dwTypeData="   1  Second ";
	si[2].dwTypeData="    Second  ";
	si[1].dwTypeData="    Second  ";
	si[0].dwTypeData="    Second  ";
	for (counter=0;counter<45;counter++) {
		si[counter].cbSize=sizeof(MENUITEMINFO);
		si[counter].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE|MIIM_CHECKMARKS;
		si[counter].fType=MFT_STRING;
		si[counter].fState=MFS_ENABLED|MFS_UNCHECKED;
		si[counter].wID=1+counter;
		si[counter].hSubMenu=NULL;
		si[counter].hbmpChecked=NULL;
		si[counter].hbmpUnchecked=NULL;
		si[counter].dwItemData=0;
		si[counter].cch=0;
	}
	si[28].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
	si[28].fType=MFT_SEPARATOR;
	si[28].fState=MFS_ENABLED;
	si[25].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
	si[25].fType=MFT_SEPARATOR;
	si[25].fState=MFS_ENABLED;
	si[15].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
	si[15].fType=MFT_SEPARATOR;
	si[15].fState=MFS_ENABLED;
	if (ttmode==1) {
		si[34].fState=si[34].fState|MFS_CHECKED;
	}
	if (fmode==1) {
		si[24].fState=si[24].fState|MFS_CHECKED;
	}
	si[(curdt-1)].fState=si[(curdt-1)].fState|MFS_CHECKED;
	if (pmode==1) {
		si[14].fState=si[14].fState|MFS_CHECKED;
	}
	si[(curtp-1)].fState=si[(curtp-1)].fState|MFS_CHECKED;
	if (submenu[0]=CreateMenu()) {
		if (InsertMenuItem(submenu[0],0,TRUE,&si[44])) {

		}
	}
	if (submenu[1]=CreateMenu()) {
		if (InsertMenuItem(submenu[1],0,TRUE,&si[34])) {

		}
	}
	if (submenu[2]=CreateMenu()) {
		for (counter=24;counter<30;counter++) {
			if (InsertMenuItem(submenu[2],0,TRUE,&si[counter])) {

			}
		}
	}
	if (submenu[3]=CreateMenu()) {
		for (counter=14;counter<24;counter++) {
			if (InsertMenuItem(submenu[3],0,TRUE,&si[counter])) {

			}
		}
	}
	if (submenu[4]=CreateMenu()) {
		for (counter=0;counter<14;counter++) {
			if (InsertMenuItem(submenu[4],0,TRUE,&si[counter])) {

			}
		}
	}
	mi[4].dwTypeData="  Update Speed ";
	mi[3].dwTypeData="  Job Options ";
	mi[2].dwTypeData="  Printer Options ";
	mi[1].dwTypeData="  Startup Options ";
	mi[0].dwTypeData="  File ";
	for (counter=0;counter<5;counter++) {
		mi[counter].cbSize=sizeof(MENUITEMINFO);
		mi[counter].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU;
		mi[counter].fType=MFT_STRING;
		mi[counter].fState=MFS_ENABLED;
		mi[counter].wID=200+counter;
		mi[counter].hSubMenu=submenu[counter];
		mi[counter].hbmpChecked=NULL;
		mi[counter].hbmpUnchecked=NULL;
		mi[counter].dwItemData=0;
	}
	if (menu=CreateMenu()) {
		for (counter=0;counter<5;counter++) {
			if (InsertMenuItem(menu,0,TRUE,&mi[counter])) {

			}
		}
	}
}

void create_cursor(void)
{
	// 1 = TRANSPARENT
	BYTE ANDmask[] =
	    {
		0xF9,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0xFF,0xFF,0xFF,
		0xF0,0x3F,0xFF,0xFF,
		0xF0,0x07,0xFF,0xFF,
		0xF0,0x03,0xFF,0xFF,
		0xF0,0x00,0xFF,0xFF,
		0x90,0x00,0x7F,0xFF,
		0x00,0x00,0x7F,0xFF,
		0x00,0x00,0x7F,0xFF,
		0x80,0x00,0x7F,0xFF,
		0xC0,0x00,0x7F,0xFF,
		0xC0,0x00,0x7F,0xFF,
		0xE0,0x00,0x7F,0xFF,
		0xE0,0x00,0xFF,0xFF,
		0xF0,0x00,0xFF,0xFF,
		0xF0,0x00,0xFF,0xFF,
		0xF8,0x01,0xFF,0xFF,
		0xF8,0x01,0xFF,0xFF,
		0xFC,0x03,0xFF,0xFF,
		0xFC,0x03,0xFF,0xFF,
		0xFC,0x03,0xFF,0xFF,
		0xFC,0x03,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,
	};

	// 1 = WHITE
	BYTE XORmask[] =
	    {
		0x00,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0x00,0x00,0x00,
		0x06,0xC0,0x00,0x00,
		0x06,0xD8,0x00,0x00,
		0x06,0xD8,0x00,0x00,
		0x06,0xDB,0x00,0x00,
		0x66,0xDB,0x00,0x00,
		0x77,0xFB,0x00,0x00,
		0x37,0xFF,0x00,0x00,
		0x1F,0xFF,0x00,0x00,
		0x1F,0xFF,0x00,0x00,
		0x0F,0xFF,0x00,0x00,
		0x0F,0xFE,0x00,0x00,
		0x07,0xFE,0x00,0x00,
		0x07,0xFE,0x00,0x00,
		0x03,0xFC,0x00,0x00,
		0x03,0xFC,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,
	};

	cursor_Handle=CreateCursor(handle_Instance,6,0,32,32,ANDmask,XORmask);
}

void timer0_on(void)
{
	if (timer0_status==FALSE) {
		timer0_Handle=SetTimer(0,0,mseconds,(TIMERPROC)timer0_code);
		if (timer0_Handle) {
			timer0_status=TRUE;
		}
	}
}

void timer0_off(void)
{
	if (timer0_status==TRUE) {
		if (KillTimer(NULL,timer0_Handle)) {
			timer0_status=FALSE;
		}
	}
}

void timer0_code(void)
{
	if (tc0==0) {
		tc0=1;
		update_status();
		tc0=0;
	}
}

void timer1_on(void)
{
	if (timer1_status==FALSE) {
		timer1_Handle=SetTimer(0,0,400,(TIMERPROC)timer1_code);
		if (timer1_Handle) {
			timer1_status=TRUE;
		}
	}
}

void timer1_off(void)
{
	if (timer1_status==TRUE) {
		if (KillTimer(NULL,timer1_Handle)) {
			timer1_status=FALSE;
		}
	}
}

void timer1_code(void)
{
	if (tc1==0) {
		tc1=1;
		pause_status(1);
		tc1=0;
	}
}

void timer2_on(void)
{
	if (timer2_status==FALSE) {
		timer2_Handle=SetTimer(0,0,3000,(TIMERPROC)timer2_code);
		if (timer2_Handle) {
			timer2_status=TRUE;
		}
	}
}

void timer2_off(void)
{
	if (timer2_status==TRUE) {
		if (KillTimer(NULL,timer2_Handle)) {
			timer2_status=FALSE;
		}
	}
}

void timer2_code(void)
{
	if (tc2==0) {
		tc2=1;
		delete_oldjobs();
		tc2=0;
	}
}

BOOL Create_ToolTip(char ttNumber,char *textTT)
{
	INITCOMMONCONTROLSEX iccex;
	TOOLINFO ti;
	HWND handle_ToolTip;
	iccex.dwICC=ICC_WIN95_CLASSES;
	iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
	InitCommonControlsEx(&iccex);
	handle_ToolTip=CreateWindowEx(WS_EX_TOPMOST,TOOLTIPS_CLASS,NULL,
		WS_POPUP|TTS_NOPREFIX|TTS_ALWAYSTIP,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		wnd0Ptr,NULL,handle_Instance,NULL);
	if (handle_ToolTip) {
		SetWindowPos(handle_ToolTip,HWND_TOPMOST,0,100,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
		ti.cbSize=sizeof(TOOLINFO);
		ti.uFlags=TTF_SUBCLASS;
		ti.hwnd=btnPtrs[ttNumber];
		ti.hinst=handle_Instance;
		ti.uId=0;
		ti.lpszText=textTT;
		ti.rect.left=0;
		ti.rect.top=0;
		ti.rect.right=108;
		ti.rect.bottom=60;
		if (ttNumber>7) {
			ti.rect.right=129;
		}
		SendMessage(handle_ToolTip,TTM_ADDTOOL,0,(LPARAM)(LPTOOLINFO) &ti);
		SendMessage(handle_ToolTip,TTM_SETMAXTIPWIDTH,0,300);
		return TRUE;
	}
	return FALSE;
}

void save_settings(char *filename)
{
	FILE *settings;
	int character=0;
	char stgbuf[256];
	settings=fopen(filename,"wb");
	if (settings!=NULL) {
		character=fputc(curtp,settings);
		if (character!=EOF) {
			character=fputc(pmode,settings);
			if (character!=EOF) {
				character=fputc(curdt,settings);
				if (character!=EOF) {
					character=fputc(fmode,settings);
					if (character!=EOF) {
						character=fputc(ttmode,settings);
						if (character!=EOF) {

						}
					}
				}
			}
		}
		character=fclose(settings);
		if (character!=EOF) {

		}
		else {
			// File did not Close.
		}
	}
	else {
		// file did not open.
	}
}

void load_settings(char *filename)
{
	FILE *settings;
	int character=0,fsize=0,position=0;
	// Open the File.
	settings=fopen(filename,"rb");
	if (settings!=NULL) {
		// Get the file Size.
		character=fgetc(settings);
		while (character!=EOF) {
			position++;
			character=fgetc(settings);
		}
		fsize=position;
		if (fsize==5) {
			// Calculate/Convert the data.
			rtn=fseek(settings,0,SEEK_SET);
			if (rtn==0) {
				curtp=fgetc(settings);
				if ((curtp<1) && (curtp>14)) {
					curtp=6;
				}
				oldtp=curtp;
				mseconds=(250*curtp);
				if (curtp==13) {
					mseconds=3500;
				}
				if (curtp==14) {
					mseconds=1;
				}
				pmode=fgetc(settings);
				if ((pmode<0) && (pmode>1)) {
					pmode=1;
				}
				curdt=fgetc(settings);
				if ((curdt<17) && (curdt>24)) {
					curdt=20;
				}
				olddt=curdt;
				deltime=(curdt-16);
				fmode=fgetc(settings);
				if ((fmode<0) && (fmode>1)) {
					fmode=1;
				}
				ttmode=fgetc(settings);
				if ((ttmode<0) && (ttmode>1)) {
					ttmode=1;
				}
			}
		}
		else {
			// Incorrect file size.
		}
		character=fclose(settings);
		if (character!=EOF) {

		}
		else {
			// File did not Close.
		}
	}
	else {
		// file don`t exist.
	}
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,INT nCmdShow)
{
	SYSTEMTIME stime;
	MSG msg;
	HANDLE mutex_handle;
	char counter=0;
	char txt0[ ]="Print ALL Jobs.";
	char txt1[ ]="Delete ALL Jobs.\n\nThe Currently Printing Job Cannot Be Deleted.";
	char txt2[ ]="Pause ALL Jobs.\n\nAvoid Accidental Printing!";
	char txt3[ ]="Ready (Prepare) ALL Jobs For Printing.";
	char txt4[ ]="Print The Selected Jobs.";
	char txt5[ ]="Delete The Selected Jobs.\n\nThe Currently Printing Job Cannot Be Deleted.";
	char txt6[ ]="Pause The Selected Jobs.\n\nAvoiding Accidental Printing.";
	char txt7[ ]="Ready (Prepare) The Selected Jobs For Printing.";
	char txt8[ ]="Pause The Printer.\n\nSuspend Printing Of Any More Jobs.";
	char txt9[ ]="UnPause The Printer.\n\nMake The Printer Ready For Printing.";
	handle_Instance=hInstance;
	mutex_handle=CreateMutex(NULL,TRUE,"PrintJob Manager");
	if (mutex_handle) {
		rtn=GetLastError();
		if (rtn!=ERROR_ALREADY_EXISTS) {
			rtn=InitApplication();
			if (rtn==1) {
				load_settings("PJM.Settings");
				create_cursor();
				create_menu();
				wnd0Ptr=Create_Window(0,"JWW0","",WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_CAPTION|WS_CLIPSIBLINGS|WS_CLIPCHILDREN,0,0,800,512);
				if (wnd0Ptr) {
					if (menu)
						SetMenu(wnd0Ptr,menu);
					btnPtrs[0]=Create_Owner(6,312,109,61);
					if (btnPtrs[0]) {
						btnPtrs[1]=Create_Owner(122,312,109,61);
						if (btnPtrs[1]) {
							btnPtrs[2]=Create_Owner(6,381,109,61);
							if (btnPtrs[2]) {
								btnPtrs[3]=Create_Owner(122,381,109,61);
								if (btnPtrs[3]) {
									btnPtrs[4]=Create_Owner(563,312,109,61);
									if (btnPtrs[4]) {
										btnPtrs[5]=Create_Owner(679,312,109,61);
										if (btnPtrs[5]) {
											btnPtrs[6]=Create_Owner(563,381,109,61);
											if (btnPtrs[6]) {
												btnPtrs[7]=Create_Owner(679,381,109,61);
												if (btnPtrs[7]) {
													btnPtrs[8]=Create_Owner(332,312,130,61);
													if (btnPtrs[8]) {
														btnPtrs[9]=Create_Owner(332,381,130,61);
														if (btnPtrs[9]) {

															bmPtrs[0]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP400),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[1]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP700),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[2]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1200),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[3]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1300),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[4]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1000),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[5]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1100),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[6]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP800),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[7]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP900),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[8]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1400),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[9]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1500),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[10]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP2100),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[11]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP2200),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[12]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1800),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[13]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1900),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[14]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1600),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[15]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP1700),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[16]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP2300),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[17]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP2400),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[18]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP2500),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
															bmPtrs[19]=LoadImage(handle_Instance,MAKEINTRESOURCE(IDBITMAP2600),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);

															if (ttmode==1) {
																if (Create_ToolTip(0,txt0)) {
																	if (Create_ToolTip(1,txt1)) {
																		if (Create_ToolTip(2,txt2)) {
																			if (Create_ToolTip(3,txt3)) {
																				if (Create_ToolTip(4,txt4)) {
																					if (Create_ToolTip(5,txt5)) {
																						if (Create_ToolTip(6,txt6)) {
																							if (Create_ToolTip(7,txt7)) {
																								if (Create_ToolTip(8,txt8)) {
																									if (Create_ToolTip(9,txt9)) {

																									}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}

															if (cursor_Handle) {
																if (SetClassLong(wnd0Ptr,GCL_HCURSOR,(LONG)cursor_Handle)) {
																	if (SetClassLong(btnPtrs[0],GCL_HCURSOR,(LONG)cursor_Handle)) {
																		if (SetClassLong(btnPtrs[1],GCL_HCURSOR,(LONG)cursor_Handle)) {
																			if (SetClassLong(btnPtrs[2],GCL_HCURSOR,(LONG)cursor_Handle)) {
																				if (SetClassLong(btnPtrs[3],GCL_HCURSOR,(LONG)cursor_Handle)) {
																					if (SetClassLong(btnPtrs[4],GCL_HCURSOR,(LONG)cursor_Handle)) {
																						if (SetClassLong(btnPtrs[5],GCL_HCURSOR,(LONG)cursor_Handle)) {
																							if (SetClassLong(btnPtrs[6],GCL_HCURSOR,(LONG)cursor_Handle)) {
																								if (SetClassLong(btnPtrs[7],GCL_HCURSOR,(LONG)cursor_Handle)) {
																									if (SetClassLong(btnPtrs[8],GCL_HCURSOR,(LONG)cursor_Handle)) {
																										if (SetClassLong(btnPtrs[9],GCL_HCURSOR,(LONG)cursor_Handle)) {

																											}
																									}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}

															open_printer();
															if (prt_opened==1) {
																if (prt_dc) {

																		enum_jobs2(0,999);
																	totjobs=curjobs;
																	delete_oldjobs();
																	pause_status(0);

																		timer0_on();
																	timer1_on();
																	timer2_on();

																		ShowWindow(wnd0Ptr,nCmdShow);
																	UpdateWindow(wnd0Ptr);

																		while (GetMessage(&msg,NULL,0,0)) {
																		TranslateMessage(&msg);
																		DispatchMessage(&msg);
																	}

																		delete_dc();
																}
																else {
																	MessageBox(NULL,"Could Not CreateDC!","  PrintJob Manager V1.00",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
																}
																close_printer();
															}
															else {
																MessageBox(NULL,"Could Not OPEN The Printer!","  PrintJob Manager V1.00",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
															}
															timer2_off();
															timer1_off();
															timer0_off();
															if (cursor_Handle)
																    DestroyCursor(cursor_Handle);
															for (counter=0;counter<20;counter++) {
																if (bmPtrs[counter]) {

																	}
															}
															if (mutex_handle)
																    ReleaseMutex(mutex_handle);
															return msg.wParam;
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
			if (mutex_handle)
				    ReleaseMutex(mutex_handle);
		}
		else {
			MessageBox(NULL,"PrintJob Manager V1.00 is already running!","  PrintJob Manager V1.00",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
			return 1;
		}
	}
	else {
		MessageBox(NULL,"Could Not CreateMutex()","  PrintJob Manager V1.00",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
		return 1;
	}
	return 0;
}
